require 'test_helper'
require 'schmetterling/dsl'

class DslTest < Test::Unit::TestCase

  class User
    def foo; end
  end

  class Configuration
    include Schmetterling::DSL

    def initialize(twitter)
      @twitter = twitter
    end

    def enable
      After(User, :foo) do |user|
        @twitter.publish(user, "some text")
      end
    end
  end

  def setup
    @twitter = mock("Twitter")
    @configuration = Configuration.new(@twitter)
    @configuration.enable
  end

  def test_invokes_the_advice
    @user = User.new
    @twitter.expects(:publish).with(@user, "some text")
    @user.foo
  end

end
